if (typeof ALUTEPLUGIN !== 'object') {
    ALUTEPLUGIN = {
        "helppage": "/help/FAQ/no_practice.html",
        "downloadpage": "/download/tools.html"
    };
}

(function() {

    function isIEPluginInstalled(pluginDef) {
        //check if plugin exists
        var plugin = false;
        try {
            plugin = new ActiveXObject(pluginDef.activeXName);
        } catch (e) {
        }


        if (plugin) {
            return true;
        } else {
            return null;
        }
    }

    function isNpapiPluginInstalled(pluginDef) {
        var name = pluginDef.npapiname;

        if (typeof (navigator.plugins[name]) != "undefined") {
            return true;
        }
        return false;
    }

    function initializedCallback() {
        if ("string" == typeof (ALUTEPLUGIN.alute_init)) {
            alute_swf_obj.call_function(ALUTEPLUGIN.alute_init);
            delete ALUTEPLUGIN.alute_init;
        }
    }

    function initializePluginWrapper() {
        if ("object" != typeof (ALUTEPLUGIN.pluginobj)) {
            ALUTEPLUGIN.pluginobj = new Object();

            ALUTEPLUGIN.pluginobj.start_record = function(args) {
                alute_plugin_obj.start_record(args);
            }

            ALUTEPLUGIN.pluginobj.playback = function(args) {
                alute_plugin_obj.playback(args);
            }

            ALUTEPLUGIN.pluginobj.stop = function(args) {
                alute_plugin_obj.stop(args);
            }

            ALUTEPLUGIN.pluginobj.recognize_record = function(args) {
                return alute_plugin_obj.recognize_record(args);
            }

            ALUTEPLUGIN.pluginobj.load_record = function(args) {
                alute_plugin_obj.load_record(args);
            }

            ALUTEPLUGIN.pluginobj.post_record = function(args) {
                return alute_plugin_obj.post_record(args);
            }

            ALUTEPLUGIN.pluginobj.save_record = function(args) {
                alute_plugin_obj.save_record(args);
            }

            ALUTEPLUGIN.pluginobj.save_records = function(args) {
                alute_plugin_obj.save_records(args);
            }

            ALUTEPLUGIN.pluginobj.cancel_upload = function(args) {
                return alute_plugin_obj.cancel_upload(args);
            }

            ALUTEPLUGIN.pluginobj.get_record_info = function(args) {
                return alute_plugin_obj.get_record_info(args);
            }
            
            ALUTEPLUGIN.pluginobj.get_record = function(args) {
                return alute_plugin_obj.get_record(args);
            }

            ALUTEPLUGIN.pluginobj.set_buffer_count = function(track_num) {
                alute_plugin_obj.set_buffer_count(track_num);
            }

            ALUTEPLUGIN.pluginobj.get_buffer_count = function() {
                return alute_plugin_obj.get_buffer_count();
            }

            ALUTEPLUGIN.pluginobj.get_max_buffer_count = function() {
                return alute_plugin_obj.get_max_buffer_count();
            }

            ALUTEPLUGIN.pluginobj.get_desktop_path = function() {
                return alute_plugin_obj.desktop_path;
            }
            
            ALUTEPLUGIN.pluginobj.remove_record = function(args) {
                return alute_plugin_obj.filesystem_remove(args);
            }
            
            ALUTEPLUGIN.pluginobj.exists_record = function(args) {
                return alute_plugin_obj.filesystem_exists(args);
            }
        }
    }

    var alute_plugin_id = "alute";
    var alute_recognizer_url = "";
    var alute_plugin_obj;
    var alute_swf_obj;
    var alute_plugin_version = "";

    var alute_info = {
        "name": "alute",
        "npapiname": "Alo7 Voice Plugin",
        "mimeType": "application/x-saybot-alute",
        "activeXName": "Saybot.alute",
        "oldversionActiveXName": "SaybotDsrClient.Factory",
        "guid": "${FBControl_GUID}",
        "installURL": {
            "win": "${PLUGIN_NAME}_installer.msi"
        }
    };

    if (typeof ALUTEPLUGIN.alutePluginLoaded !== 'function') {
        ALUTEPLUGIN.alutePluginLoaded = function() {
            alute_swf_obj = document.getElementById(ALUTEPLUGIN.alute_swf_id);
            alute_plugin_obj = document.getElementById(alute_plugin_id);
            alute_plugin_obj.set_recognition_url(alute_recognizer_url);
            alute_plugin_obj.set_jskey_funchost(alute_swf_obj);
            initializePluginWrapper();
            initializedCallback();
        }
    }

    if (typeof ALUTEPLUGIN.defaultRecognizerUrl !== 'function') {
        ALUTEPLUGIN.defaultRecognizerUrl = function(url) {
            alute_recognizer_url = url;
            if (alute_plugin_obj) {
                alute_plugin_obj.set_recognition_url(alute_recognizer_url);
            }
        }
    }

    if (typeof ALUTEPLUGIN.doAluteInitialize !== 'function') {
        ALUTEPLUGIN.doAluteInitialize = function(str) {
            ALUTEPLUGIN.alute_init = str;
            if (!alute_swf_obj) {
                if (ALUTEPLUGIN.alute_swf_id) {
                    alute_swf_obj = document.getElementById(ALUTEPLUGIN.alute_swf_id);
                } else {
                    return false;
                }
            }

            if (alute_plugin_obj) {
                initlizedCallback();
                return true;
            } else {
                var html = "";
                html += "<object id='" + alute_plugin_id + "' type= '" + alute_info.mimeType + "' >";
                html += "<param name='onload' value='pluginInit' />";
                html += "</object>";
                document.getElementById("pluginContainer").innerHTML = html;
                return true;
            }

        }
    }

    if (typeof ALUTEPLUGIN.unload_alute !== 'function') {
        ALUTEPLUGIN.unload_alute = function() {
            delete ALUTEPLUGIN.alute_init;
            if (alute_plugin_obj) {
                alute_plugin_obj = false;
                document.getElementById("pluginContainer").innerHTML = "";
            }
            return true;
        }
    }


    if (typeof ALUTEPLUGIN.isInitialized !== 'function') {
        ALUTEPLUGIN.isInitialized = function() {
            if (alute_plugin_obj) {
                return true;
            } else {
                return false
            }
        }
    }

    if (typeof ALUTEPLUGIN.version !== 'function') {
        ALUTEPLUGIN.version = function() {
            if (ALUTEPLUGIN.isAluteInstall()) {
                if (alute_plugin_obj) {
                    return alute_plugin_obj.version;
                } else {
                    return "";
                }
            } else if (ALUTEPLUGIN.isOldpluginInstall()) {
                plugin = new ActiveXObject(alute_info.oldversionActiveXName);
                return plugin.version;
            } else {
                return ""
            }
        }
    }

    if (typeof ALUTEPLUGIN.isAluteInstall !== 'function') {
        ALUTEPLUGIN.isAluteInstall = function() {
            //check if plugin exists
            if (window.ActiveXObject || "ActiveXObject" in window) {
                // We're running IE
                return isIEPluginInstalled(alute_info)
            } else if (navigator.plugins) {
                // We're running something else
                return isNpapiPluginInstalled(alute_info)
            }
        }
    }

    if (typeof ALUTEPLUGIN.isOldpluginInstall !== 'function') {
        ALUTEPLUGIN.isOldpluginInstall = function() {
            //check if plugin exists
            if (window.ActiveXObject || "ActiveXObject" in window) {
                // We're running IE
                var plugin = false;
                try {
                    plugin = new ActiveXObject(alute_info.oldversionActiveXName);
                } catch (e) {
                }
                if (plugin) {
                    return true;
                } else {
                    return null;
                }
            } else {
                // We're running something else
                return false;
            }
        }
    }

    if (typeof ALUTEPLUGIN.navigateDownload !== 'function') {
        ALUTEPLUGIN.navigateDownload = function() {
            window.open(ALUTEPLUGIN.downloadpage, '_blank');
        }
    }

    if (typeof ALUTEPLUGIN.navigateHelp !== 'function') {
        ALUTEPLUGIN.navigateHelp = function(url) {
            window.open(ALUTEPLUGIN.helppage, '_blank');
        }
    }
}());

function pluginInit() {
    ALUTEPLUGIN.alutePluginLoaded();
}